searchNodes=[{"ref":"OffBroadway.MQTT.html","title":"OffBroadway.MQTT","type":"module","doc":"A broadway producer for MQTT topic subscriptions."},{"ref":"OffBroadway.MQTT.html#config/1","title":"OffBroadway.MQTT.config/1","type":"function","doc":"Returns the runtime configuration for OffBroadway.MQTT. See f:OffBroadway.MQTT.Config.new/1 for more details."},{"ref":"OffBroadway.MQTT.html#fail_msg/2","title":"OffBroadway.MQTT.fail_msg/2","type":"function","doc":"Adds the second argument as error to one or many message(s)."},{"ref":"OffBroadway.MQTT.html#queue_name/1","title":"OffBroadway.MQTT.queue_name/1","type":"function","doc":"Returns the name for the queue belonging to the given topic."},{"ref":"OffBroadway.MQTT.html#queue_name/2","title":"OffBroadway.MQTT.queue_name/2","type":"function","doc":"Returns the name for the queue belonging to the given topic."},{"ref":"OffBroadway.MQTT.html#topic_from_queue_name/1","title":"OffBroadway.MQTT.topic_from_queue_name/1","type":"function","doc":"Returns the topic name from a queue_name/0."},{"ref":"OffBroadway.MQTT.html#unique_client_id/1","title":"OffBroadway.MQTT.unique_client_id/1","type":"function","doc":"Utility function to build a for the running application unique client id that can be used when connecting with the broker. This ensures that multiple clients from the same application don&#39;t kick each other from the broker in case the broker does not allow multiple connections with the same clent id."},{"ref":"OffBroadway.MQTT.html#t:config/0","title":"OffBroadway.MQTT.config/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.html#t:qos/0","title":"OffBroadway.MQTT.qos/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.html#t:queue_name/0","title":"OffBroadway.MQTT.queue_name/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.html#t:subscription/0","title":"OffBroadway.MQTT.subscription/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.html#t:topic/0","title":"OffBroadway.MQTT.topic/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Acknowledger.html","title":"OffBroadway.MQTT.Acknowledger","type":"module","doc":"Implements Broadway.Acknowledger behaviour. Special exceptions with a ack field can tell the acknowledger to :ignore or :retry a message if it reached the end of the pipeline. For every other exception an error is logged with the the exception&#39;s message/1 result as message."},{"ref":"OffBroadway.MQTT.Acknowledger.html#t:ack_data/0","title":"OffBroadway.MQTT.Acknowledger.ack_data/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Client.html","title":"OffBroadway.MQTT.Client","type":"module","doc":"Implemens the default MQTT client that is used by the producer to connect to the broker. The client establishes the connection to OffBroadway.MQTT broker subscribes to the provided topic wrapping the received payload in a OffBroadway.MQTT.Data.t/0 struct. enques received and wrapped messages to the passed queue This module relies on Tortoise and Tortoise.Supervisor.start_child/1 establish the connection and subscribe to the topic."},{"ref":"OffBroadway.MQTT.Client.html#start/4","title":"OffBroadway.MQTT.Client.start/4","type":"function","doc":"Starts a MQTT client for the passed subscription with a random client id. When passing :default as the first argument f:OffBroadway.MQTT.config/1 is used to figure out the connection. Options :client_id - Can be used to set the client id for the connection. If not given a random client id is generated. sub_ack - A Process.dest/0 that receives a message as soon as the subscription is acknowledged. The subscriber receives a message in the form {:subscription, client_id, topic, status}."},{"ref":"OffBroadway.MQTT.Client.html#t:option/0","title":"OffBroadway.MQTT.Client.option/0","type":"type","doc":"Type for options for start/4. :client_id - Can be used to set the client id for the connection. If not given a random client id is generated. sub_ack - A Process.dest/0 that receives a message as soon as the subscription is acknowledged. The subscriber receives a message in the form {:subscription, client_id, topic, status}."},{"ref":"OffBroadway.MQTT.Client.html#t:options/0","title":"OffBroadway.MQTT.Client.options/0","type":"type","doc":"Collection type for all options that can be passed to start/4"},{"ref":"OffBroadway.MQTT.Config.html","title":"OffBroadway.MQTT.Config","type":"module","doc":"Defines a data structure for configuring this library. Config options dequeue_interval - The interval used by the producer to timout polls to the queue process. Defaults to 5000. client_id_prefix - The value is used to prefix the randomly generated client ids by the MQTT client. Defaults to &quot;obmp&quot;. Keep in mind that some brokers limit the size of client_id size to 23 bytes! server_opts - See the &quot;Server options&quot; section for details. telemetry_prefix - Sets the prefix for any telemery events. Defaults to :off_broadway_mqtt. Server options All options given with the server_opts option are passed to Tortoise when starting the connection process. The following options can be given: host - The host the MQTT client uses by default. Defaults to &#39;localhost&#39;. port - The port the MQTT client uses by default. Defaults to 1883. transport - The protocol the MQTT client uses by default. Defaults to :tcp. See Tortoise.Connection.start_link/1 for further options. Dependency injection Besides the other config options it is also possible to replace some modules used by providing an alternative implementation: queue_supervisor - The supervisor that supervises the queue processes started by the producer. Defaults to OffBroadway.MQTT.QueueSupervisor. queue_registry - The registry that is used to register the queue processes started by the producer. Defaults to OffBroadway.MQTT.QueueRegistry. acknowledger - The Broadway.Acknowledger implementation used when building the message strucs. client - The MQTT client module. handler- The handler module used by the default client. queue - The queue used in the handler and producer to enqueue / dequeue messages. Compiletime configuration The following options must be given at compile time: telemetry_enabled - Enables telemetry events if set to true. This option is disabled by default. Configuration example use Mix.Config config :off_broadway_mqtt, client_id_prefix: &quot;sensor_data_processor&quot;, server_opts: [ host: &quot;vernemq&quot;, port: 8883, transport: :ssl ], handler: MyApp.BetterHandler Building configurations iex&gt; OffBroadway.MQTT.Config.new() %OffBroadway.MQTT.Config{ acknowledger: OffBroadway.MQTT.Acknowledger, client: OffBroadway.MQTT.Client, client_id_prefix: &quot;obmp&quot;, dequeue_interval: 5000, handler: OffBroadway.MQTT.Handler, producer: OffBroadway.MQTT.Producer, queue: OffBroadway.MQTT.Queue, queue_registry: OffBroadway.MQTT.QueueRegistry, queue_supervisor: OffBroadway.MQTT.QueueSupervisor, server: {:tcp, [host: &#39;localhost&#39;, port: 1883]}, telemetry_prefix: :off_broadway_mqtt } iex&gt; OffBroadway.MQTT.Config.new( ...&gt; telemetry_prefix: :test, ...&gt; server_opts: [host: &quot;vernemq&quot;, port: 8883, transport: :ssl] ...&gt; ) %OffBroadway.MQTT.Config{ acknowledger: OffBroadway.MQTT.Acknowledger, client: OffBroadway.MQTT.Client, client_id_prefix: &quot;obmp&quot;, dequeue_interval: 5000, handler: OffBroadway.MQTT.Handler, producer: OffBroadway.MQTT.Producer, queue: OffBroadway.MQTT.Queue, queue_registry: OffBroadway.MQTT.QueueRegistry, queue_supervisor: OffBroadway.MQTT.QueueSupervisor, server: {:ssl, [host: &#39;vernemq&#39;, port: 8883]}, telemetry_prefix: :test }"},{"ref":"OffBroadway.MQTT.Config.html#new/1","title":"OffBroadway.MQTT.Config.new/1","type":"function","doc":"Returns a t/0. If no argument or :default is passed the configuration reads values from the Application environment."},{"ref":"OffBroadway.MQTT.Config.html#new/2","title":"OffBroadway.MQTT.Config.new/2","type":"function","doc":"Returns a t/0. If no argument or :default is passed the configuration reads values from the Application environment. The second argument is used to override values in the config."},{"ref":"OffBroadway.MQTT.Config.html#t:option/0","title":"OffBroadway.MQTT.Config.option/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Config.html#t:options/0","title":"OffBroadway.MQTT.Config.options/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Config.html#t:raw_server_opt/0","title":"OffBroadway.MQTT.Config.raw_server_opt/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Config.html#t:raw_server_opts/0","title":"OffBroadway.MQTT.Config.raw_server_opts/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Config.html#t:server/0","title":"OffBroadway.MQTT.Config.server/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Config.html#t:server_opt/0","title":"OffBroadway.MQTT.Config.server_opt/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Config.html#t:server_opts/0","title":"OffBroadway.MQTT.Config.server_opts/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Config.html#t:t/0","title":"OffBroadway.MQTT.Config.t/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Config.html#t:transport/0","title":"OffBroadway.MQTT.Config.transport/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Data.html","title":"OffBroadway.MQTT.Data","type":"module","doc":"Defines a data structure for the data passed around in the Broadway.Message.t/0 struct. :acc - The data that is being processed in a pipeline. :topic - A list with the fragments of the topic the data is coming from. :meta - A with map arbitrary metadata."},{"ref":"OffBroadway.MQTT.Data.html#t:t/0","title":"OffBroadway.MQTT.Data.t/0","type":"type","doc":"Type for the internal data structure passed around with the Broadway.Message.t/0. :acc - The data that is being processed in a pipeline. :topic - A list with the fragments of the topic the data is coming from. :meta - A with map arbitrary metadata."},{"ref":"OffBroadway.MQTT.Error.html","title":"OffBroadway.MQTT.Error","type":"exception","doc":"Exceptions can be used to influence the behaviour of the message acknowledger. See OffBroadway.MQTT.Acknowledger for more details."},{"ref":"OffBroadway.MQTT.Error.html#t:t/0","title":"OffBroadway.MQTT.Error.t/0","type":"type","doc":""},{"ref":"OffBroadway.MQTT.Producer.html","title":"OffBroadway.MQTT.Producer","type":"module","doc":"Acts as Producer for messages from a MQTT topic subscription. Features Retrying messages based on fail reason in the message status. Telemetry events. Gently handles connection outages thanks to Tortoise. Customizeable behaviour by dependency injection. Options The producer requires on start a single argument - a list containing as the first element a OffBroadway.MQTT.Config.t/0 struct. Refere to the OffBroadway.MQTT.Config module for more info. second element a tuple with the subscription : {:subscription, {&quot;some_topic&quot;, 0}}. Any further keywords are passed as options to OffBroadway.MQTT.Client.start/2. Notes The buffer queues are started and registered based on topics. If you are using shared subscriptions you will have a single queue for buffering the incoming messages. The default queue keeps buffered messages only in memory. If the queue supervisor terminates all unprocessed messages are lost. The buffer queues are supervised independently and don&#39;t shut down with the producer. That way a restarted producer on the same topic can pick up where the faulty one stopped. You might need to stop queues manually if stopping a producer on purpose."},{"ref":"OffBroadway.MQTT.Producer.html#t:args/0","title":"OffBroadway.MQTT.Producer.args/0","type":"type","doc":"Type for the argument passed to the producer on start."},{"ref":"OffBroadway.MQTT.Producer.html#t:opt/0","title":"OffBroadway.MQTT.Producer.opt/0","type":"type","doc":"Type for optios that can be passed to the producer. subscription - A tuple with the topic and QOS to subscribe to. Any other option is passed to OffBroadway.MQTT.Client.start/4 as options. Refere there for further options."},{"ref":"OffBroadway.MQTT.Producer.html#t:opts/0","title":"OffBroadway.MQTT.Producer.opts/0","type":"type","doc":"Collection type for options to start the producer with."},{"ref":"OffBroadway.MQTT.Producer.html#t:state/0","title":"OffBroadway.MQTT.Producer.state/0","type":"type","doc":"Internal state of the producer."},{"ref":"OffBroadway.MQTT.Queue.html","title":"OffBroadway.MQTT.Queue","type":"behaviour","doc":"Implemens a inmemory queue to buffer incoming messages for a subscription from a MQTT broker."},{"ref":"OffBroadway.MQTT.Queue.html#child_spec/1","title":"OffBroadway.MQTT.Queue.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"OffBroadway.MQTT.Queue.html#dequeue/2","title":"OffBroadway.MQTT.Queue.dequeue/2","type":"function","doc":"Dequeues the demanded amount of messages from the given queue."},{"ref":"OffBroadway.MQTT.Queue.html#c:dequeue/2","title":"OffBroadway.MQTT.Queue.dequeue/2","type":"callback","doc":"Called by the Tortoise.Handler to enqueue incoming messages."},{"ref":"OffBroadway.MQTT.Queue.html#enqueue/2","title":"OffBroadway.MQTT.Queue.enqueue/2","type":"function","doc":"Enqueues the message."},{"ref":"OffBroadway.MQTT.Queue.html#c:enqueue/2","title":"OffBroadway.MQTT.Queue.enqueue/2","type":"callback","doc":"Called by the producer to dequeue messages."},{"ref":"OffBroadway.MQTT.Queue.html#start_link/1","title":"OffBroadway.MQTT.Queue.start_link/1","type":"function","doc":"Starts a queue with the given name."},{"ref":"OffBroadway.MQTT.Queue.html#c:start_link/1","title":"OffBroadway.MQTT.Queue.start_link/1","type":"callback","doc":"Called by the producer to start a new queue. This usually receives a t:MQTT.queue_name/0 as argument."},{"ref":"OffBroadway.MQTT.Queue.html#t:name/0","title":"OffBroadway.MQTT.Queue.name/0","type":"type","doc":"Type for queue_names"},{"ref":"readme.html","title":"OffBroadway.MQTT","type":"extras","doc":"OffBroadway.MQTT A MQTT connector for Broadway."},{"ref":"readme.html#installation","title":"OffBroadway.MQTT - Installation","type":"extras","doc":"Add off_broadway_mqtt_connector to the list of dependencies in mix.exs: def deps do [ {:off_broadway_mqtt_connector, &quot;~&gt; 0.1.0&quot;} ] end Notice that the package has a different name than the application!"},{"ref":"readme.html#usage","title":"OffBroadway.MQTT - Usage","type":"extras","doc":"Add it as a producer to your Broadway: defmodule MyApp.NincompoopFilter do use OffBroadway.MQTT defmodule Nincompoop do defexception ack: :ignore, message: nil def message(e) do &quot;message is probably coming from a nincompoop: &quot; &lt;&gt; e.message end end def start_link(config, topic) do Broadway.start_link(__MODULE__, name: __MODULE__, producers: [ default: [ module: {Producer, [config, subscription: {topic, 0}]}, stages: 1 ] ], processors: [default: [stages: 1]], batchers: [ default: [stages: 1, batch_size: 10] ] ) end @impl true def handle_message(_processor_name, message, _context) do message |&gt; Message.update_data(&amp;process_data/1) rescue e -&gt; Message.failed(message, e) end defp process_data(%OffBroadway.MQTT.Data{acc: msg} = data) do msg |&gt; String.downcase() |&gt; String.contains?(&quot;great again&quot;) |&gt; case do true -&gt; raise Nincompoop, &quot;contains \\&quot;great again\\&quot;&quot; false -&gt; data end end @impl true def handle_batch(_, messages, _batch_info, _context) do # ... messages end end Start it by passing it at least a OffBroadway.MQTT.Config.t/0 and the subscription option with a topic to subscribe to and the desired QOS. For further options refer to the OffBroadway.MQTT.Producer docs. Default values for the configuration can be given via the mix config: use Mix.Config config :off_broadway_mqtt, client_id_prefix: &quot;sensor_data_processor&quot;, server_opts: [ host: &quot;vernemq&quot;, port: 8883, transport: :ssl ], handler: MyApp.BetterHandler Then build a config and start your broadway: # Builds a configuration with all configured default values config = OffBroadway.MQTT.Config.new() # Builds a configuration from the defaults and overrides values config = OffBroadway.MQTT.Config.new( client_id_prefix: &quot;myapp&quot;, server_opts: [ # host is converted into a `charlist` host: &quot;mosquitto&quot;, # port is converted into a `integer` if it is not already one port: &quot;1883&quot;, transport: :tcp, username: &quot;admin&quot;, password: &quot;admin&quot; ] ) # Start broadway MyApp.NincompoopFilter.start(config, &quot;test_topic&quot;)"},{"ref":"readme.html#telemetry-events","title":"OffBroadway.MQTT - Telemetry events","type":"extras","doc":"Telemetry events are disabled by default. To enable them the following must be configured at compile time: use Mix.Config config :off_broadway_mqtt, telemetry_enabled: true, A prefix can be configured that is used to prefix any telemetry event. use Mix.Config config :off_broadway_mqtt, telemetry_prefix: :my_broadway, The prefix can also be passed at runtime with the OffBroadway.MQTT.Config.t/0 to the producer. The following events are emitted: my_broadway.client.connection.up.count my_broadway.client.connection.down.count my_broadway.client.subscription.up.count my_broadway.client.subscription.down.count my_broadway.client.messages.count my_broadway.queue.in.count my_broadway.queue.in.size my_broadway.queue.out.count my_broadway.queue.out.size my_broadway.acknowledger.success.count my_broadway.acknowledger.failed.count my_broadway.acknowledger.ignored.count my_broadway.acknowledger.requeued.count"},{"ref":"readme.html#development","title":"OffBroadway.MQTT - Development","type":"extras","doc":"For development you probably need a running MQTT server in your develoment environment. The provided docker-compose.yml starts a vernemq container for you. Then run the following commands: mix deps.get mix test The documentation can be generated with mix docs. Code coverage report can be generated with mix coveralls.html."},{"ref":"readme.html#license","title":"OffBroadway.MQTT - License","type":"extras","doc":"Copyright 2019 Kristopher Bredemeier Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License."}]